# Generated by Django 3.2.16 on 2023-02-16 13:07

import django.db.models.deletion
from django.db import migrations, models


class Migration(migrations.Migration):
    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="RedirectGroup",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=50, unique=True)),
                (
                    "next_url",
                    models.URLField(
                        help_text="the url to redirect to",
                        unique=True,
                        verbose_name="next url",
                    ),
                ),
            ],
            options={
                "permissions": [
                    ("redirect_notify", "get shown a link when you would be redirected")
                ],
            },
        ),
        migrations.CreateModel(
            name="WrinklyPage",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=50)),
                (
                    "title",
                    models.CharField(blank=True, max_length=30, verbose_name="titel"),
                ),
                ("content", models.TextField(verbose_name="inhoud")),
            ],
        ),
        migrations.CreateModel(
            name="UrlSpace",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "url",
                    models.URLField(
                        db_index=True, unique=True, verbose_name="Relative Url"
                    ),
                ),
                (
                    "contenttype",
                    models.CharField(
                        choices=[
                            (None, "(Unknown)"),
                            ("Rg", "Redirect Group"),
                            ("Wp", "Wrinkly Page"),
                            ("Re", "Reserved"),
                        ],
                        default="Re",
                        max_length=2,
                        verbose_name="Content type",
                    ),
                ),
                (
                    "redirect_group",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="wrinklypages.redirectgroup",
                        verbose_name="Maybe Redirect Group",
                    ),
                ),
                (
                    "wrinkly_page",
                    models.OneToOneField(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="wrinklypages.wrinklypage",
                        verbose_name="Maybe Wrinkly Page",
                    ),
                ),
            ],
        ),
        migrations.AddConstraint(
            model_name="urlspace",
            constraint=models.CheckConstraint(
                check=models.Q(
                    models.Q(("contenttype", "Wp"), _negated=True),
                    ("wrinkly_page__isnull", False),
                    _connector="OR",
                ),
                name="if_url_is_wrinkly_then_url_has_wrinklypage",
            ),
        ),
        migrations.AddConstraint(
            model_name="urlspace",
            constraint=models.CheckConstraint(
                check=models.Q(
                    models.Q(("contenttype", "Rg"), _negated=True),
                    ("redirect_group__isnull", False),
                    _connector="OR",
                ),
                name="if_url_is_redirect_then_url_has_redirectgroup",
            ),
        ),
    ]
